summaryrefslogtreecommitdiff
path: root/140
diff options
context:
space:
mode:
authorLachlan McIlroy <lachlan@sgi.com>2006-12-05 05:07:45 +0000
committerLachlan McIlroy <lachlan@sgi.com>2006-12-05 05:07:45 +0000
commit8434010b7952aa1787dc550ec0ebfbace4c8b587 (patch)
tree774dfb34eeeb7ac9f668573d2701255bafdf6712 /140
parent3508b5ae4ab25dd330d29799653858da589cfa67 (diff)
More tests for the NULL files problem
Merge of master-melb:xfs-cmds:27632a by kenmcd. Fix test number and simplify test case
Diffstat (limited to '140')
-rwxr-xr-x14080
1 files changed, 80 insertions, 0 deletions
diff --git a/140 b/140
new file mode 100755
index 00000000..5c4bbf1d
--- /dev/null
+++ b/140
@@ -0,0 +1,80 @@
+#! /bin/sh
+# FSQA Test No. 140
+#
+# Test for NULL files problem
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2006 Silicon Graphics, Inc. All Rights Reserved.
+#-----------------------------------------------------------------------
+#
+# creator
+owner=lachlan@sgi.com
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ _cleanup_testdir
+}
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+
+# real QA test starts here
+_supported_fs xfs
+_supported_os Linux IRIX
+
+_setup_testdir
+_require_scratch
+_scratch_mkfs_xfs >/dev/null 2>&1
+_scratch_mount
+
+# create files
+i=1;
+while [ $i -lt 1000 ]
+do
+ file=$SCRATCH_MNT/$i
+ xfs_io -f -c "pwrite -b 32k -S 0xff 0 32k" $file > /dev/null
+ xfs_io -f -c "truncate 64k" $file > /dev/null
+ i=`expr $i + 1`
+done
+
+# give the system a chance to write something out
+sleep 10
+
+src/godown $SCRATCH_MNT
+
+umount $SCRATCH_MNT
+_scratch_mount
+
+# check file size and contents
+i=1;
+while [ $i -lt 1000 ]
+do
+ file=$SCRATCH_MNT/$i
+ # if file does not exist, the create was not logged, skip it
+ if [ -e $file ]
+ then
+ # if file size is zero it cannot be corrupt, skip it
+ if [ -s $file ]
+ then
+ # if file has non-zero size but no extents then it's contents will be NULLs, bad.
+ if xfs_bmap $file | grep 'no extents' > /dev/null
+ then
+ echo corrupt file $file - non-zero size but no extents
+ fi
+ fi
+ rm -f $file
+ fi
+ i=`expr $i + 1`
+done
+
+status=0
+exit